<?php
if (!defined("ROOT_PATH"))
{
	header("HTTP/1.1 403 Forbidden");
	exit;
}
class pjInvoiceModel extends pjInvoiceAppModel
{
	protected $primaryKey = 'id';
	
	protected $table = 'plugin_invoice';
	
	protected $schema = array(
		array('name' => 'id', 'type' => 'int', 'default' => ':NULL'),
		array('name' => 'uuid', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'order_id', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'foreign_id', 'type' => 'int', 'default' => ':NULL'),
		array('name' => 'locale_id', 'type' => 'int', 'default' => ':NULL'),
		array('name' => 'issue_date', 'type' => 'date', 'default' => ':NULL'),
		array('name' => 'due_date', 'type' => 'date', 'default' => ':NULL'),
		array('name' => 'created', 'type' => 'datetime', 'default' => ':NOW()'),
		array('name' => 'modified', 'type' => 'datetime', 'default' => ':NULL'),
		array('name' => 'status', 'type' => 'enum', 'default' => 'not_paid'),
		array('name' => 'payment_method', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'txn_id', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'processed_on', 'type' => 'datetime', 'default' => ':NULL'),
		array('name' => 'price', 'type' => 'decimal', 'default' => 0),
		array('name' => 'discount', 'type' => 'decimal', 'default' => 0),
		array('name' => 'insurance', 'type' => 'decimal', 'default' => 0),
		array('name' => 'shipping', 'type' => 'decimal', 'default' => 0),
		array('name' => 'tax', 'type' => 'decimal', 'default' => 0),
		array('name' => 'total', 'type' => 'decimal', 'default' => 0),
		array('name' => 'currency', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'notes', 'type' => 'text', 'default' => ':NULL'),
		array('name' => 'b_name', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'b_country_id', 'type' => 'int', 'default' => ':NULL'),
		array('name' => 'b_state', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'b_city', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'b_zip', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'b_address_1', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 'b_address_2', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 's_name', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 's_country_id', 'type' => 'int', 'default' => ':NULL'),
		array('name' => 's_state', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 's_city', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 's_zip', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 's_address_1', 'type' => 'varchar', 'default' => ':NULL'),
		array('name' => 's_address_2', 'type' => 'varchar', 'default' => ':NULL')
	);
	
	protected $validate = array(
		'rules' => array(
			'uuid' => array(
				'pjActionAlphaNumeric' => true,
				'pjActionNotEmpty' => true,
				'pjActionRequired' => true
			),
			'order_id' => array(
				'pjActionAlphaNumeric' => true,
				'pjActionNotEmpty' => true,
				'pjActionRequired' => true
			),
			'foreign_id' => array(
				'pjActionNumeric' => true,
				'pjActionNotEmpty' => true,
				'pjActionRequired' => true
			),
			'status' => array(
				'pjActionNotEmpty' => true,
				'pjActionRequired' => true
			)
		)
	);
	
	public static function factory($attr=array())
	{
		return new pjInvoiceModel($attr);
	}
	
	public function pjActionSetup()
	{
		
	}
	
	public function getInvoiceID()
	{
		$id = 1;
		$arr = $this
			->reset()
			->limit(1)
			->orderBy("id DESC")
			->findAll()
			->getData();
		if(!empty($arr))
		{
			$id = $arr[0]['id'] + 1;
		}
	
		return $id;
	}
}
?>
